Index: kernel/arch/mips32/Makefile.inc
===================================================================
--- kernel/arch/mips32/Makefile.inc	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/mips32/Makefile.inc	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -63,4 +63,5 @@
 	arch/$(KARCH)/src/debug/stacktrace.c \
 	arch/$(KARCH)/src/debug/stacktrace_asm.S \
+	arch/$(KARCH)/src/mm/km.c \
 	arch/$(KARCH)/src/mm/frame.c \
 	arch/$(KARCH)/src/mm/page.c \
Index: kernel/arch/mips32/include/mm/as.h
===================================================================
--- kernel/arch/mips32/include/mm/as.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/mips32/include/mm/as.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -39,5 +39,5 @@
 
 #define KERNEL_ADDRESS_SPACE_START_ARCH  UINT32_C(0x80000000)
-#define KERNEL_ADDRESS_SPACE_END_ARCH    UINT32_C(0x9fffffff)
+#define KERNEL_ADDRESS_SPACE_END_ARCH    UINT32_C(0xffffffff)
 #define USER_ADDRESS_SPACE_START_ARCH    UINT32_C(0x00000000)
 #define USER_ADDRESS_SPACE_END_ARCH      UINT32_C(0x7fffffff)
Index: kernel/arch/mips32/include/mm/frame.h
===================================================================
--- kernel/arch/mips32/include/mm/frame.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/mips32/include/mm/frame.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -41,5 +41,6 @@
 #ifndef __ASM__
 
-extern void frame_arch_init(void);
+extern void frame_low_arch_init(void);
+extern void frame_high_arch_init(void);
 extern void physmem_print(void);
 
Index: kernel/arch/mips32/include/mm/km.h
===================================================================
--- kernel/arch/mips32/include/mm/km.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ kernel/arch/mips32/include/mm/km.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,56 @@
+/*
+ * Copyright (c) 2011 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup mips32mm
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_mips32_KM_H_
+#define KERN_mips32_KM_H_
+
+#include <typedefs.h>
+
+#define KM_MIPS32_KSEG0_START	UINT32_C(0x80000000)
+#define KM_MIPS32_KSEG0_SIZE	UINT32_C(0x20000000)
+
+#define KM_MIPS32_KSSEG_START	UINT32_C(0xc0000000)
+#define KM_MIPS32_KSSEG_SIZE	UINT32_C(0x20000000)
+
+#define KM_MIPS32_KSEG3_START	UINT32_C(0xe0000000)
+#define KM_MIPS32_KSEG3_SIZE	UINT32_C(0x20000000)
+
+extern void km_identity_arch_init(void);
+extern void km_non_identity_arch_init(void);
+extern bool km_is_non_identity_arch(uintptr_t);
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/mips32/src/mips32.c
===================================================================
--- kernel/arch/mips32/src/mips32.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/mips32/src/mips32.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -34,31 +34,21 @@
 
 #include <arch.h>
-#include <arch/cp0.h>
-#include <arch/exception.h>
-#include <arch/debug.h>
-#include <mm/as.h>
+#include <typedefs.h>
+#include <errno.h>
+#include <interrupt.h>
+#include <macros.h>
+#include <str.h>
+#include <memstr.h>
 #include <userspace.h>
-#include <memstr.h>
-#include <proc/thread.h>
-#include <abi/proc/uarg.h>
-#include <print.h>
 #include <console/console.h>
 #include <syscall/syscall.h>
 #include <sysinfo/sysinfo.h>
-#include <arch/interrupt.h>
-#include <interrupt.h>
-#include <console/chardev.h>
-#include <arch/barrier.h>
+#include <arch/debug.h>
 #include <arch/debugger.h>
+#include <arch/drivers/msim.h>
 #include <genarch/fb/fb.h>
-#include <abi/fb/visuals.h>
 #include <genarch/drivers/dsrln/dsrlnin.h>
 #include <genarch/drivers/dsrln/dsrlnout.h>
 #include <genarch/srln/srln.h>
-#include <macros.h>
-#include <config.h>
-#include <str.h>
-#include <arch/drivers/msim.h>
-#include <arch/asm/regname.h>
 
 /* Size of the code jumping to the exception handler code
@@ -88,5 +78,5 @@
 	size_t i;
 	for (i = 0; i < init.cnt; i++) {
-		init.tasks[i].addr = (uintptr_t) bootinfo->tasks[i].addr;
+		init.tasks[i].paddr = KA2PA(bootinfo->tasks[i].addr);
 		init.tasks[i].size = bootinfo->tasks[i].size;
 		str_cpy(init.tasks[i].name, CONFIG_TASK_NAME_BUFLEN,
@@ -248,7 +238,7 @@
  * possible to have it separately in the future.
  */
-sysarg_t sys_tls_set(sysarg_t addr)
-{
-	return 0;
+sysarg_t sys_tls_set(uintptr_t addr)
+{
+	return EOK;
 }
 
Index: kernel/arch/mips32/src/mm/frame.c
===================================================================
--- kernel/arch/mips32/src/mm/frame.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/mips32/src/mm/frame.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -123,5 +123,5 @@
 	for (i = 0; i < init.cnt; i++)
 		if (overlaps(frame << ZERO_PAGE_WIDTH, ZERO_PAGE_SIZE,
-		    KA2PA(init.tasks[i].addr), init.tasks[i].size)) {
+		    init.tasks[i].paddr, init.tasks[i].size)) {
 			safe = false;
 			break;
@@ -131,25 +131,38 @@
 }
 
-static void frame_add_region(pfn_t start_frame, pfn_t end_frame)
-{
-	if (end_frame > start_frame) {
-		/* Convert 1M frames to 16K frames */
-		pfn_t first = ADDR2PFN(start_frame << ZERO_PAGE_WIDTH);
-		pfn_t count = ADDR2PFN((end_frame - start_frame) << ZERO_PAGE_WIDTH);
-		
+static void frame_add_region(pfn_t start_frame, pfn_t end_frame, bool low)
+{
+	if (end_frame <= start_frame)
+		return;
+
+	uintptr_t base = start_frame << ZERO_PAGE_WIDTH;
+	size_t size = (end_frame - start_frame) << ZERO_PAGE_WIDTH;
+
+	if (!frame_adjust_zone_bounds(low, &base, &size))
+		return; 
+
+	pfn_t first = ADDR2PFN(base);
+	size_t count = SIZE2FRAMES(size);
+	pfn_t conf_frame;
+
+	if (low) {
 		/* Interrupt vector frame is blacklisted */
-		pfn_t conf_frame;
 		if (first == 0)
 			conf_frame = 1;
 		else
 			conf_frame = first;
-		
-		zone_create(first, count, conf_frame, 0);
-		
-		if (phys_regions_count < MAX_REGIONS) {
-			phys_regions[phys_regions_count].start = first;
-			phys_regions[phys_regions_count].count = count;
-			phys_regions_count++;
-		}
+		zone_create(first, count, conf_frame,
+		    ZONE_AVAILABLE | ZONE_LOWMEM);
+	} else {
+		conf_frame = zone_external_conf_alloc(count);
+		if (conf_frame != 0)
+			zone_create(first, count, conf_frame,
+			    ZONE_AVAILABLE | ZONE_HIGHMEM);
+	}
+	
+	if (phys_regions_count < MAX_REGIONS) {
+		phys_regions[phys_regions_count].start = first;
+		phys_regions[phys_regions_count].count = count;
+		phys_regions_count++;
 	}
 }
@@ -165,5 +178,5 @@
  *
  */
-void frame_arch_init(void)
+void frame_low_arch_init(void)
 {
 	ipl_t ipl = interrupts_disable();
@@ -224,5 +237,5 @@
 		
 		if (!avail) {
-			frame_add_region(start_frame, frame);
+			frame_add_region(start_frame, frame, true);
 			start_frame = frame + 1;
 			avail = true;
@@ -230,5 +243,5 @@
 	}
 	
-	frame_add_region(start_frame, frame);
+	frame_add_region(start_frame, frame, true);
 	
 	/* Blacklist interrupt vector frame */
@@ -246,4 +259,7 @@
 }
 
+void frame_high_arch_init(void)
+{
+}
 
 void physmem_print(void)
Index: kernel/arch/mips32/src/mm/km.c
===================================================================
--- kernel/arch/mips32/src/mm/km.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ kernel/arch/mips32/src/mm/km.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,58 @@
+/*
+ * Copyright (c) 2011 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup mips32mm
+ * @{
+ */
+
+#include <arch/mm/km.h>
+#include <mm/km.h>
+#include <config.h>
+#include <typedefs.h>
+#include <macros.h>
+
+void km_identity_arch_init(void)
+{
+	config.identity_base = KM_MIPS32_KSEG0_START;
+	config.identity_size = KM_MIPS32_KSEG0_SIZE;
+}
+
+void km_non_identity_arch_init(void)
+{
+	km_non_identity_span_add(KM_MIPS32_KSSEG_START, KM_MIPS32_KSSEG_SIZE);
+	km_non_identity_span_add(KM_MIPS32_KSEG3_START, KM_MIPS32_KSEG3_SIZE);
+}
+
+bool km_is_non_identity_arch(uintptr_t addr)
+{
+	return iswithin(KM_MIPS32_KSSEG_START, KM_MIPS32_KSSEG_SIZE, addr, 1)
+	    || iswithin(KM_MIPS32_KSEG3_START, KM_MIPS32_KSEG3_SIZE, addr, 1);
+}
+
+/** @}
+ */
Index: kernel/arch/mips32/src/mm/page.c
===================================================================
--- kernel/arch/mips32/src/mm/page.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/mips32/src/mm/page.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -41,13 +41,5 @@
 {
 	page_mapping_operations = &pt_mapping_operations;
-}
-
-/** Map device into kernel space
- * - on mips, all devices are already mapped into kernel space,
- *   translate the physical address to uncached area
- */
-uintptr_t hw_map(uintptr_t physaddr, size_t size)
-{
-	return physaddr + 0xa0000000;
+	as_switch(NULL, AS_KERNEL);
 }
 
Index: kernel/arch/mips32/src/mm/tlb.c
===================================================================
--- kernel/arch/mips32/src/mm/tlb.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/mips32/src/mm/tlb.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -95,8 +95,5 @@
 	
 	badvaddr = cp0_badvaddr_read();
-	
-	mutex_lock(&AS->lock);
 	asid = AS->asid;
-	mutex_unlock(&AS->lock);
 	
 	pte = find_mapping_and_check(badvaddr, PF_ACCESS_READ, istate, &pfrc);
Index: kernel/arch/mips64/Makefile.inc
===================================================================
--- kernel/arch/mips64/Makefile.inc	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/mips64/Makefile.inc	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -55,4 +55,5 @@
 	arch/$(KARCH)/src/debug/stacktrace.c \
 	arch/$(KARCH)/src/debug/stacktrace_asm.S \
+	arch/$(KARCH)/src/mm/km.c \
 	arch/$(KARCH)/src/mm/frame.c \
 	arch/$(KARCH)/src/mm/page.c \
Index: kernel/arch/mips64/include/mm/frame.h
===================================================================
--- kernel/arch/mips64/include/mm/frame.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/mips64/include/mm/frame.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -41,5 +41,6 @@
 #ifndef __ASM__
 
-extern void frame_arch_init(void);
+extern void frame_low_arch_init(void);
+extern void frame_high_arch_init(void);
 extern void physmem_print(void);
 
Index: kernel/arch/mips64/include/mm/km.h
===================================================================
--- kernel/arch/mips64/include/mm/km.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ kernel/arch/mips64/include/mm/km.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,47 @@
+/*
+ * Copyright (c) 2011 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup mips64mm
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_mips64_KM_H_
+#define KERN_mips64_KM_H_
+
+#include <typedefs.h>
+
+extern void km_identity_arch_init(void);
+extern void km_non_identity_arch_init(void);
+extern bool km_is_non_identity_arch(uintptr_t);
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/mips64/src/mips64.c
===================================================================
--- kernel/arch/mips64/src/mips64.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/mips64/src/mips64.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -34,31 +34,21 @@
 
 #include <arch.h>
-#include <arch/cp0.h>
-#include <arch/exception.h>
-#include <arch/debug.h>
-#include <mm/as.h>
+#include <typedefs.h>
+#include <errno.h>
+#include <interrupt.h>
+#include <macros.h>
+#include <str.h>
+#include <memstr.h>
 #include <userspace.h>
-#include <memstr.h>
-#include <proc/thread.h>
-#include <abi/proc/uarg.h>
-#include <print.h>
 #include <console/console.h>
 #include <syscall/syscall.h>
 #include <sysinfo/sysinfo.h>
-#include <arch/interrupt.h>
-#include <interrupt.h>
-#include <console/chardev.h>
-#include <arch/barrier.h>
+#include <arch/debug.h>
 #include <arch/debugger.h>
+#include <arch/drivers/msim.h>
 #include <genarch/fb/fb.h>
-#include <abi/fb/visuals.h>
 #include <genarch/drivers/dsrln/dsrlnin.h>
 #include <genarch/drivers/dsrln/dsrlnout.h>
 #include <genarch/srln/srln.h>
-#include <macros.h>
-#include <config.h>
-#include <str.h>
-#include <arch/drivers/msim.h>
-#include <arch/asm/regname.h>
 
 /* Size of the code jumping to the exception handler code
@@ -88,5 +78,5 @@
 	size_t i;
 	for (i = 0; i < init.cnt; i++) {
-		init.tasks[i].addr = (uintptr_t) bootinfo->tasks[i].addr;
+		init.tasks[i].paddr = KA2PA(bootinfo->tasks[i].addr);
 		init.tasks[i].size = bootinfo->tasks[i].size;
 		str_cpy(init.tasks[i].name, CONFIG_TASK_NAME_BUFLEN,
@@ -226,7 +216,7 @@
  * possible to have it separately in the future.
  */
-sysarg_t sys_tls_set(sysarg_t addr)
-{
-	return 0;
+sysarg_t sys_tls_set(uintptr_t addr)
+{
+	return EOK;
 }
 
Index: kernel/arch/mips64/src/mm/frame.c
===================================================================
--- kernel/arch/mips64/src/mm/frame.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/mips64/src/mm/frame.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -115,5 +115,5 @@
 	for (i = 0; i < init.cnt; i++)
 		if (overlaps(frame << ZERO_PAGE_WIDTH, ZERO_PAGE_SIZE,
-		    KA2PA(init.tasks[i].addr), init.tasks[i].size)) {
+		    init.tasks[i].paddr, init.tasks[i].size)) {
 			safe = false;
 			break;
@@ -123,25 +123,38 @@
 }
 
-static void frame_add_region(pfn_t start_frame, pfn_t end_frame)
-{
-	if (end_frame > start_frame) {
-		/* Convert 1M frames to 16K frames */
-		pfn_t first = ADDR2PFN(start_frame << ZERO_PAGE_WIDTH);
-		pfn_t count = ADDR2PFN((end_frame - start_frame) << ZERO_PAGE_WIDTH);
-		
+static void frame_add_region(pfn_t start_frame, pfn_t end_frame, bool low)
+{
+	if (end_frame <= start_frame)
+		return;
+
+	uintptr_t base = start_frame << ZERO_PAGE_WIDTH;
+	size_t size = (end_frame - start_frame) << ZERO_PAGE_WIDTH;
+
+	if (!frame_adjust_zone_bounds(low, &base, &size))
+		return; 
+
+	pfn_t first = ADDR2PFN(base);
+	size_t count = SIZE2FRAMES(size);
+	pfn_t conf_frame;
+
+	if (low) {
 		/* Interrupt vector frame is blacklisted */
-		pfn_t conf_frame;
 		if (first == 0)
 			conf_frame = 1;
 		else
 			conf_frame = first;
-		
-		zone_create(first, count, conf_frame, 0);
-		
-		if (phys_regions_count < MAX_REGIONS) {
-			phys_regions[phys_regions_count].start = first;
-			phys_regions[phys_regions_count].count = count;
-			phys_regions_count++;
-		}
+		zone_create(first, count, conf_frame,
+		    ZONE_AVAILABLE | ZONE_LOWMEM);
+	} else {
+		conf_frame = zone_external_conf_alloc(count);
+		if (conf_frame != 0)
+			zone_create(first, count, conf_frame,
+			    ZONE_AVAILABLE | ZONE_HIGHMEM);
+	}
+	
+	if (phys_regions_count < MAX_REGIONS) {
+		phys_regions[phys_regions_count].start = first;
+		phys_regions[phys_regions_count].count = count;
+		phys_regions_count++;
 	}
 }
@@ -156,5 +169,5 @@
  *
  */
-void frame_arch_init(void)
+void frame_low_arch_init(void)
 {
 	ipl_t ipl = interrupts_disable();
@@ -207,5 +220,5 @@
 		
 		if (!avail) {
-			frame_add_region(start_frame, frame);
+			frame_add_region(start_frame, frame, true);
 			start_frame = frame + 1;
 			avail = true;
@@ -213,5 +226,5 @@
 	}
 	
-	frame_add_region(start_frame, frame);
+	frame_add_region(start_frame, frame, true);
 	
 	/* Blacklist interrupt vector frame */
@@ -229,4 +242,8 @@
 }
 
+void frame_high_arch_init(void)
+{
+}
+
 void physmem_print(void)
 {
Index: kernel/arch/mips64/src/mm/km.c
===================================================================
--- kernel/arch/mips64/src/mm/km.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ kernel/arch/mips64/src/mm/km.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,50 @@
+/*
+ * Copyright (c) 2011 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup mips64mm
+ * @{
+ */
+
+#include <arch/mm/km.h>
+#include <typedefs.h>
+
+void km_identity_arch_init(void)
+{
+}
+
+void km_non_identity_arch_init(void)
+{
+}
+
+bool km_is_non_identity_arch(uintptr_t addr)
+{
+	return false;
+}
+
+/** @}
+ */
Index: kernel/arch/mips64/src/mm/page.c
===================================================================
--- kernel/arch/mips64/src/mm/page.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/mips64/src/mm/page.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -43,13 +43,4 @@
 }
 
-/** Map device into kernel space
- * - on mips, all devices are already mapped into kernel space,
- *   translate the physical address to uncached area
- */
-uintptr_t hw_map(uintptr_t physaddr, size_t size)
-{
-	return physaddr + 0xffffffffa0000000;
-}
-
 /** @}
  */
Index: kernel/arch/ppc32/Makefile.inc
===================================================================
--- kernel/arch/ppc32/Makefile.inc	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/ppc32/Makefile.inc	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -52,4 +52,5 @@
 	arch/$(KARCH)/src/proc/scheduler.c \
 	arch/$(KARCH)/src/ddi/ddi.c \
+	arch/$(KARCH)/src/mm/km.c \
 	arch/$(KARCH)/src/mm/as.c \
 	arch/$(KARCH)/src/mm/frame.c \
Index: kernel/arch/ppc32/include/mm/frame.h
===================================================================
--- kernel/arch/ppc32/include/mm/frame.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/ppc32/include/mm/frame.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -44,6 +44,4 @@
 #include <trace.h>
 
-extern uintptr_t last_frame;
-
 NO_TRACE static inline uint32_t physmem_top(void)
 {
@@ -58,5 +56,6 @@
 }
 
-extern void frame_arch_init(void);
+extern void frame_low_arch_init(void);
+extern void frame_high_arch_init(void);
 extern void physmem_print(void);
 
Index: kernel/arch/ppc32/include/mm/km.h
===================================================================
--- kernel/arch/ppc32/include/mm/km.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ kernel/arch/ppc32/include/mm/km.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,53 @@
+/*
+ * Copyright (c) 2011 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup ppc32mm
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_ppc32_KM_H_
+#define KERN_ppc32_KM_H_
+
+#include <typedefs.h>
+
+#define KM_PPC32_IDENTITY_START		UINT32_C(0x80000000)
+#define KM_PPC32_IDENTITY_SIZE		UINT32_C(0x40000000)
+
+#define KM_PPC32_NON_IDENTITY_START	UINT32_C(0xc0000000)
+#define KM_PPC32_NON_IDENTITY_SIZE	UINT32_C(0x40000000)
+
+extern void km_identity_arch_init(void);
+extern void km_non_identity_arch_init(void);
+extern bool km_is_non_identity_arch(uintptr_t);
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/ppc32/src/drivers/pic.c
===================================================================
--- kernel/arch/ppc32/src/drivers/pic.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/ppc32/src/drivers/pic.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -34,5 +34,5 @@
 
 #include <arch/drivers/pic.h>
-#include <mm/page.h>
+#include <mm/km.h>
 #include <byteorder.h>
 #include <bitops.h>
@@ -42,5 +42,5 @@
 void pic_init(uintptr_t base, size_t size, cir_t *cir, void **cir_arg)
 {
-	pic = (uint32_t *) hw_map(base, size);
+	pic = (uint32_t *) km_map(base, size, PAGE_WRITE | PAGE_NOT_CACHEABLE);
 	*cir = pic_ack_interrupt;
 	*cir_arg = NULL;
Index: kernel/arch/ppc32/src/mm/frame.c
===================================================================
--- kernel/arch/ppc32/src/mm/frame.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/ppc32/src/mm/frame.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -40,5 +40,4 @@
 #include <print.h>
 
-uintptr_t last_frame = 0;
 memmap_t memmap;
 
@@ -54,5 +53,5 @@
 }
 
-void frame_arch_init(void)
+static void frame_common_arch_init(bool low)
 {
 	pfn_t minconf = 2;
@@ -61,23 +60,36 @@
 	for (i = 0; i < memmap.cnt; i++) {
 		/* To be safe, make the available zone possibly smaller */
-		uintptr_t new_start = ALIGN_UP((uintptr_t) memmap.zones[i].start,
+		uintptr_t base = ALIGN_UP((uintptr_t) memmap.zones[i].start,
 		    FRAME_SIZE);
-		size_t new_size = ALIGN_DOWN(memmap.zones[i].size -
-		    (new_start - ((uintptr_t) memmap.zones[i].start)), FRAME_SIZE);
+		size_t size = ALIGN_DOWN(memmap.zones[i].size -
+		    (base - ((uintptr_t) memmap.zones[i].start)), FRAME_SIZE);
 		
-		pfn_t pfn = ADDR2PFN(new_start);
-		size_t count = SIZE2FRAMES(new_size);
-		
+		if (!frame_adjust_zone_bounds(low, &base, &size))
+			return;
+
+		pfn_t pfn = ADDR2PFN(base);
+		size_t count = SIZE2FRAMES(size);
 		pfn_t conf;
-		if ((minconf < pfn) || (minconf >= pfn + count))
-			conf = pfn;
-		else
-			conf = minconf;
-		
-		zone_create(pfn, count, conf, 0);
-		
-		if (last_frame < ALIGN_UP(new_start + new_size, FRAME_SIZE))
-			last_frame = ALIGN_UP(new_start + new_size, FRAME_SIZE);
+
+		if (low) {
+			if ((minconf < pfn) || (minconf >= pfn + count))
+				conf = pfn;
+			else
+				conf = minconf;
+			zone_create(pfn, count, conf,
+			    ZONE_AVAILABLE | ZONE_LOWMEM);
+		} else {
+			conf = zone_external_conf_alloc(count);
+			if (conf != 0)
+				zone_create(pfn, count, conf,
+				    ZONE_AVAILABLE | ZONE_HIGHMEM);
+		}
 	}
+	
+}
+
+void frame_low_arch_init(void)
+{
+	frame_common_arch_init(true);
 	
 	/* First is exception vector, second is 'implementation specific',
@@ -92,4 +104,9 @@
 }
 
+void frame_high_arch_init(void)
+{
+	frame_common_arch_init(false);
+}
+
 /** @}
  */
Index: kernel/arch/ppc32/src/mm/km.c
===================================================================
--- kernel/arch/ppc32/src/mm/km.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ kernel/arch/ppc32/src/mm/km.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,58 @@
+/*
+ * Copyright (c) 2011 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup ppc32mm
+ * @{
+ */
+
+#include <arch/mm/km.h>
+#include <mm/km.h>
+#include <config.h>
+#include <typedefs.h>
+#include <macros.h>
+
+void km_identity_arch_init(void)
+{
+	config.identity_base = KM_PPC32_IDENTITY_START;
+	config.identity_size = KM_PPC32_IDENTITY_SIZE;
+}
+
+void km_non_identity_arch_init(void)
+{
+	km_non_identity_span_add(KM_PPC32_NON_IDENTITY_START,
+	    KM_PPC32_NON_IDENTITY_SIZE);
+}
+
+bool km_is_non_identity_arch(uintptr_t addr)
+{
+	return iswithin(KM_PPC32_NON_IDENTITY_START,
+	    KM_PPC32_NON_IDENTITY_SIZE, addr, 1);
+}
+
+/** @}
+ */
Index: kernel/arch/ppc32/src/mm/page.c
===================================================================
--- kernel/arch/ppc32/src/mm/page.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/arch/ppc32/src/mm/page.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -46,24 +46,4 @@
 }
 
-uintptr_t hw_map(uintptr_t physaddr, size_t size)
-{
-	if (last_frame + ALIGN_UP(size, PAGE_SIZE) >
-	    KA2PA(KERNEL_ADDRESS_SPACE_END_ARCH))
-		panic("Unable to map physical memory %p (%zu bytes).",
-		    (void *) physaddr, size);
-	
-	uintptr_t virtaddr = PA2KA(last_frame);
-	pfn_t i;
-	page_table_lock(AS_KERNEL, true);
-	for (i = 0; i < ADDR2PFN(ALIGN_UP(size, PAGE_SIZE)); i++)
-		page_mapping_insert(AS_KERNEL, virtaddr + PFN2ADDR(i),
-		    physaddr + PFN2ADDR(i), PAGE_NOT_CACHEABLE | PAGE_WRITE);
-	page_table_unlock(AS_KERNEL, true);
-	
-	last_frame = ALIGN_UP(last_frame + size, FRAME_SIZE);
-	
-	return virtaddr;
-}
-
 /** @}
  */
